<?php
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
class getMyRSSTab extends cbTabHandler {
	function getMyRSSTab() {
		$this->cbTabHandler();
	}
	function getDisplayTab($tab,$user,$ui) {
	global $mosConfig_absolute_path, $mosConfig_cachepath;
	
	if (($user->cb_myrssone=="") && ($user->cb_myrsstwo=="") && ($user->cb_myrssthree=="") && ($user->cb_myrssfour=="") && ($user->cb_myrssfive=="")) {
		return ;
		}
	else {
			include_once('myrss.inc');
			$params=$this->params;
			$rssitems 			= $params->get( 'rssitems', 5 );
			$rssdesc 			= $params->get( 'rssdesc', 1 );
			$rssimage 			= $params->get( 'rssimage', 1 );
			$rssitemtitle_words = $params->def( 'rssitemtitle_words', 0 );
			$rssitemdesc		= $params->get( 'rssitemdesc', 0 );
			$rssitemdesc_images	= $params->get( 'rssitemdesc_images', 1 );
			$rssitemdesc_words	= $params->get( 'rssitemdesc_words', 0 );
			$rsstitle			= $params->get( 'rsstitle', 1 );
			$rsscache			= $params->get( 'rsscache', 3600 );
			$link_target		= $params->get( 'link_target', 1 );
			$override_charset	= $params->get( 'override_charset', 0 );
			$translate_encoding	= $params->get( 'translate_encoding', 1 );
			$rssitem_show_enclosure	= $params->get( 'rssitem_show_enclosure', 1 );
			$enable_tooltip     = $params->get( 'enable_tooltip','yes' );
			$tooltip_desc_words	= $params->def( 't_word_count_desc', 25 );
			$tooltip_desc_images= $params->def( 'tooltip_desc_images', 1 );
			$tooltip_title_words= $params->def( 't_word_count_title', 25 );
			$linkrel			= $params->def( 'linkrel', '' );

			$url01 = $user->cb_myrssone;
			$url02 = $user->cb_myrsstwo;
			$url03 = $user->cb_myrssthree;
			$url04 = $user->cb_myrssfour;
			$url05 = $user->cb_myrssfive;
						
			$myfeedurl = array();
			$myfeedurl[] = ''.$url01.'';
			if ($url02) {$myfeedurl[] = ''.$url02.'';}
			if ($url03) {$myfeedurl[] = ''.$url03.'';}
			if ($url04) {$myfeedurl[] = ''.$url04.'';}
			if ($url05) {$myfeedurl[] = ''.$url05.'';}
			
			
			$k=0;
				foreach ($myfeedurl as $rssurl) {
			$k++;
				// check if cache directory exists and is writeable
				$cacheDir 		= $mosConfig_absolute_path .'/cache/';	
				if ( !is_writable( $cacheDir ) ) {	
					return 'Cache Directory Unwriteable';
					$cache_exists = false;
				}else{
					$cache_exists = true;
				}

				//add support for multiple RSS feeds
				//loop through and display each newsfeed	
					$feed = new myrss();
					$feed->feed_url($rssurl);

					/**Handle RSS and Joomla encoding differences **/	
					if($override_charset){ 
						//set / override Joomla HTML page metatag charset to match RSS character encoding
						$feed->handle_content_type(); 
					}
					
					$feed_encoding = strtolower($feed->get_encoding()); //get encoding of current RSS feed
					$joomla_encoding = str_replace('charset=','',_ISO); //get Joomla configuration charset from language file
					if(($feed_encoding !== $joomla_encoding) && $translate_encoding && !$override_charset ){ 

						//convert RSS feed to default joomla encoding
					  $feed->output_encoding(strtoupper($joomla_encoding));
					}

					//check and set caching
					if($cache_exists) {
						$feed->cache_location($cacheDir);
						$feed->caching = true;
						$cache_time = (intval($rsscache) / 60); //convery from seconds to minutes
						$feed->cache_max_minutes($cache_time);
					}
					else {
						$feed->caching = false;
					}

					//$feed->replace_headers(true); //change <h1><h2> and <h3> html header tags in newsfeed to <h4>
					$feed->strip_ads(true);
					$feed->init(); //initialise the newsfeed parsing

					//start showing the feed meta-info (title, desc and image)
					$content_buffer = '';
					$content_buffer = '<table cellpadding="3" cellspacing="0" width="100%">' . "\n";

					// feed title			
					if ( $feed->get_feed_title() && $rsstitle ) {
						$content_buffer .= "<tr class=\"sectiontableheader\">\n";
						$content_buffer .= "	<td>\n";
						$content_buffer .= "		<strong>\n";
						$content_buffer .= "		<a href=\"" . $feed->get_feed_link()  . "\" title=\"".$feed->get_feed_title()."\" rel=\"".$linkrel."\" target=\"_blank\">\n";
						$content_buffer .= $feed->get_feed_title() . "</a>\n";
						$content_buffer .= "		</strong>\n";
						$content_buffer .= "	</td>\n";
						$content_buffer .= "</tr>\n";
					}

					// feed description
					if ( $rssdesc ) {
						$content_buffer .= "<tr class=\"sectiontableentry2\">\n";
						$content_buffer .= "	<td>\n";
						$content_buffer .= $feed->get_feed_description();
						$content_buffer .= "	</td>\n";
						$content_buffer .= "</tr>\n";
					}

					// feed image
					if ( $rssimage && $feed->get_image_url() ) {
						$content_buffer .= "<tr>\n";
						$content_buffer .= "	<td>\n";
						$content_buffer .= "		<div style=\"text-align:center;\"><image border=\"0\" src=\"" . $feed->get_image_url() . "\" alt=\"" . $feed->get_image_title() . "\"/></div>\n";
						$content_buffer .= "	</td>\n";
						$content_buffer .= "</tr>\n";
					}		
					//end feed meta-info
					
					//start processing feed items
					$content_buffer .= "<tr>\n";
					$content_buffer .= "	<td>\n";
					
					//if there are items in the feed
					if($feed->get_item_quantity()){	
					
					//start looping through the feed items
					foreach ($feed->get_items(0, $rssitems) as $currItem) {	

						// item title							
						$item_title = trim($currItem->get_title());

						// item title word limit check
						if ( $rssitemtitle_words ) {
							$item_titles = explode( ' ', $item_title );
							$count = count( $item_titles );
							if ( $count > $rssitemtitle_words ) {
								$item_title = '';
								for( $i=0; $i < $rssitemtitle_words; $i++ ) {
									$item_title .= ' '. $item_titles[$i];
								}
								$item_title .= '...';
							}
						}	

						// item description
						if($rssitemdesc){
							$desc = trim($currItem->get_description());
							if(!$rssitemdesc_images){
								$desc = preg_replace("/<img[^>]+\>/i", "", $desc);
							}	

							//item description word limit check
							if ( $rssitemdesc_words ) {
								$texts = explode( ' ', $desc );
								$count = count( $texts );
								if ( $count > $rssitemdesc_words ) {
									$desc = '';
									for( $i=0; $i < $rssitemdesc_words; $i++ ) {
										$desc .= ' '. $texts[$i];
									}
									$desc .= '...';
								}
							}									
						}

						// tooltip text
						if ( $enable_tooltip =='yes' ) {
							//load support js library
							mosCommonHTML::loadOverlib();

							//tooltip item title
							$t_item_title = trim($currItem->get_title());

							// tooltip title word limit check
							if ( $tooltip_title_words ) {
								$t_item_titles = explode( ' ', $t_item_title );
								$count = count( $t_item_titles );
								if ( $count > $tooltip_title_words ) {
									$tooltip_title = '';
									for( $i=0; $i < $tooltip_title_words; $i++ ) {
										$tooltip_title .= ' '. $t_item_titles[$i];
									}
									$tooltip_title .= '...';						
								}else{
									$tooltip_title = $t_item_title;	
								}
							}else{
								$tooltip_title = $t_item_title;	
							}

							//tooltip item description
							$text = trim($currItem->get_description());
							if(!$tooltip_desc_images){
								$text = preg_replace("/<img[^>]+\>/i", "", $text);
							}

							// tooltip desc word limit check
							if ( $tooltip_desc_words ) {
								$texts = explode( ' ', $text );
								$count = count( $texts );
								if ( $count > $tooltip_desc_words ) {
									$text = '';
									for( $i=0; $i < $tooltip_desc_words; $i++ ) {
										$text .= ' '. $texts[$i];
									}
									$text .= '...';
								}
							}

							//build tooltip content
							$tipField = preg_replace("/(\r\n|\n|\r)/", " ", $text); //replace new line characters in tooltip, important!
							$tipTitle = preg_replace("/(\r\n|\n|\r)/", " ", $tooltip_title); //replace new line characters in tooltip title, important!
							$style = "style=\"padding:5px;\"";
							$htmltext= "<a href=\"" . $currItem->get_permalink() . "\" title=\"".$feed->get_feed_title()."\" rel=\"".$linkrel."\" target=\"".$link_target."\">" . html_entity_decode($item_title) . "</a>";
							$tooltip = cbFieldTip($ui='', $tipField, $tipTitle, $width='400', $icon='', $htmltext, $href='', $style, $olparams='',false);
						}else{ 
							$tooltip = "<a href=\"" . $currItem->get_permalink() . "\" title=\"".$feed->get_feed_title()."\" rel=\"".$linkrel."\" target=\"".$link_target."\">" . html_entity_decode($item_title) . "</a>";
						}							

						//start assigning item content to output buffer
						if ($currItem->get_permalink()) {
							$content_buffer .= "<hr />".$tooltip."\n";
							if($rssitemdesc){ //show item desc
								$content_buffer .= "<br />" . html_entity_decode($desc) . "\n";
							}
						}   

						//check if feed has enclosure tag (used for podcasts,  embedding video / audio feeds etc...)
						if( $rssitem_show_enclosure){
						if ($enclosure = $currItem->get_enclosure() ) {
							//if it's an image, show it
							if($enclosure->get_type() == "image/jpeg" && $rssitemdesc_images){
								$content_buffer .= "<br />" .
								"<a href='" . $currItem->get_link() . "' rel=\"".$linkrel."\" title=\"".$feed->get_feed_title()."\" target='".$link_target."'>\n" .
								"<img border=\"0\" src='" . $enclosure->get_link() . "' alt='image' /></a>";
							}else{ //link to media file
								$content_buffer .= "        <a  rel=\"".$linkrel."\" title=\"".$feed->get_feed_title()."\" href=\"" . $enclosure->get_link() . "\" target=\"_blank\">\n";
								$content_buffer .= "       (". $enclosure->get_type() . " ".$enclosure->get_size()."MB )</a>\n";
							}
						}
						}		
					}				

					} //end item quantity check if statement
					$content_buffer .= "	</td>\n";
					$content_buffer .= "</tr>\n";
					$content_buffer .= "</table>\n";
				 	$return .= $content_buffer;
                  	$return .= "<br>" ;
				}		
		return $return;
		}
	}
}
?>